/***************************************************************************
 *     䠩 ᮤন     ࠡ    - *
 *  ᪮ ०.  ⠭  ᯮ짮  䠩 GRAPHICS.H   *
 *   䠩 GRAPHICS.LIB, WND_ASM.LIB.                                    *       *
 ***************************************************************************/
#ifndef  BLOCK
#include <key_asm.h>

#define Start_Video_Buf 0xA000     //砫    
#define Video_Port      0x03CE     //  ࠡ饣  ஬
#define Video_Color     0x03C4     //  ࠡ饣  梥⮬
#define Get_Interrupt   0x35     //㭪 DOS 祭 뢠
#define Set_Interrupt   0x25     //㭪 DOS ⠭ 뢠
#define Tabl_Sim_Graph  0x1F     //  ᮤঠ騩 㪠⥫
				   // ⠡ ᪨ ᨬ
#define Va_Str_Buf      0x0090     //   va_ 㭪権
#define Line_Next_Col   0x0050     //⢮  室  室
				   //    ᫥ ப
#define Set_Video_Mode  0x0000     //㭪 BIOS_10  ⠭ ࠡ
				   //ᯫ

#define  MAXY  349      //ᨬ쭮 祭 ᥫ  ⨪
#define  XORI   0x1F    //  "᪫饥 "
#define  ANDI   0x0F    //  ""
#define  COPI   0x07    //   
#define  ORI    0x17	//   ""

#define  H_ELP    0x00  //뢮  ᪠
#define  E_RROR   0x01  //뢮  訡
#define  W_ARNING 0x02  //뢮  ।०

//   ० ࠡ ஢ EGA, VGA  ( ० MODE )
#define V_40_25_0    0x00
#define V_40_25_1    0x01
#define V_80_25_0    0x02
#define V_80_25_1    0x03
#define V_320_200_0  0x04
#define V_320_200_1  0x05
#define V_640_200_0  0x06
#define V_MONO       0x07
#define V_320_200_2  0x0D
#define V_640_200_2  0x0E
#define V_640_350_0  0x0F
#define V_640_350_1  0x10

#define NO_SIM 100

typedef  void ( far *FUN )( void );       //뢠 㪠⥫  㭪
typedef  void ( far *FUN_POINT )( void ); //뢠 㪠⥫  㭪
typedef  void ( far *TEXT_FUN )(int,int,const int );

//  ⨯  ᠭ  祭
typedef unsigned char VARIABL;      // ।塞 ந ⨯
typedef unsigned char BOOLEAN;      // ।塞 ᪨ ⨯
typedef unsigned char COLOR;        // ।塞 ⨯ 梥
typedef unsigned char MODE;         // ।塞 ⨯  ०

/*****              樨                 *****/
typedef struct
	       {
	         int X1, X2;  // 砫    樨 
               }LOCATE;

/*****               ࠧ                    *****/
typedef struct                        //  ࠦ
               {
	         int X1, Y1,               // 孨 㣮 
	             X2, Y2;               //ࠢ   㣮 
	       }BLOCK;

/*****                                    *****/
typedef struct
               {
	          BLOCK  Window;     //  ᪠
                  char   far *Text_Help; //  ᪠
               } HELP;


/*****   ᠭ  ᮧ ᭮  ᢨ *****/
typedef struct
	       {
	         LOCATE     Curs_Light; //  ᢥ⪨  롮
                 char      far *Title;      //  㭪  
                 char      far *Hot_Key;    // 稥  맮 
                                        // 㭪 
		 FUN_POINT Exec;        // 㭪 뢠  롮
				        // ᮮ⢥饣 㭪 
		 HELP      Window;
	       }DEIS;

typedef struct { float far  *X,far  *Y;  } DATA;

typedef struct
       {  int x1, y1,  // 孨 㣮 
	      x2, y2;  // ࠢ 㣮 
          int kol;     //⢮ ⮢  
          char far *keys;  //ப   
       } MENU;

typedef struct
       {  int x1, y1,  // 孨 㣮 
	      x2, y2;  // ࠢ 㣮 
          int kol;     //⢮ ⮢  
          char far *title; //  롮
          char far *keys;  //ப   
       } VID;

typedef struct
       {  int x1, y1,  // 孨 㣮 
	      x2, y2;  // ࠢ 㣮 
	  int kol;     //⢮ ⮢  
	  char far *title; //  롮
	  KEY far *keys;  //ப   
       } VIDI;

typedef struct
       {  int   x1, y1, //孨  㣮  ᪠
                x2, y2; // ࠢ 㣮  ᪠
          COLOR color1, // ⥪ 
                color2; // 뤥 
	  char   far *name; // 㭪 
          char   far *help; // ᪠
          FUN       sf; //⥫  㭪 ࠡ⪨  㭪
       } FUNCTION;

typedef struct
       {  int   x1, y1, //孨  㣮  ᪠
                x2, y2; // ࠢ 㣮  ᪠
          COLOR color1, // ⥪ 
		color2, // 롮  㭪
                zam;    //㡫஢ 䫠 롮 (   ESC )
	  char   far *name; // 㭪 
          char   far *help; // ᪠
          FUN       sf; //⥫  㭪 ࠡ⪨  㭪
       } CASE;

typedef struct
       {  int   x1, y1, //孨  㣮  ᪠
		x2, y2; // ࠢ 㣮  ᪠
	  COLOR color1, // ⥪ 
		color2, // 롮  㭪
		zam;    //㡫஢ 䫠 롮 (   ESC )
	  char  far *name; // 㭪 
	  int   help_x,
		help_y1,
		help_y2;
	  char  far *Data;
	  char  far *help; // ᪠
	  FUN       sf; //⥫  㭪 ࠡ⪨  㭪
       } CASEI;


typedef struct
       { char  far *Title;      //  
	 int   X1, Y1,      // न 
	       X2, Y2;
	 int   Kol_String;    // ⢮ ப   ⠡
	 int   Kol_Punct;    // ⢮ ⮫殢  ⠡
	 char  far * far *Names_Tabl; // ⥫   ⠡
	 int   far *Line; 	     // ⥫   ࠧ⪨ ⠡
	 TEXT_FUN Text_View;    // ⥫  㭪 뢮   ࠭
       }SHOW_RECORD;

//       
void Set_Init_Window( MODE );                  //⠭ ० ࠭
void Chan_Block_Xor( BLOCK far *, COLOR, MODE );    //   . XOR
void Set_Block(BLOCK far *, int, int, int, int);    //⠭ ࠧ 
void Chan_Block( int, int, int, int, COLOR,
                 MODE );                       // 梥 
                                               //ࠦ  樥 XOR
void Chan_Pixel( int, int, COLOR, MODE );      // 梥 ᥫ
					       //ࠦ  樥 XOR
//void Set_Graph_Sim( void );                    //⠭ ᪨ ᨬ.
//void Back_Graph_Sim( void );                   //⠭. ० ᨬ
void Chand( int, int, int, int, COLOR, MODE ); //ந.  
void Print( int, int, COLOR, COLOR, char far * );   //⭮ 뢮 ⥪
void textxy (int x, int y, char far *s);
void Gprintf( int, int, char far *, ... );          //ଠ஢ 뢮 ⥪-
					       //  ᪨ ࠭
void Fun_Bar( char far *str );                     //뢮 ப 㭪樮
					       //
MODE Find_Key( char far *str, char sim );          //  ᨬ
void Common_Menu( CASE far *, CASE far *, MODE );        //뢮  ᪠,
                                               //訡, ।०
void Close_System( void );                     //⨥  ⥬,
                                               //䠩, 室  ணࠬ
void Menu_Deis( void );                        //ࠡ⪠  ⢨
void Init_Case_Wnd( VID  *wnd, CASE far *fn,        // 筮 롮
		    MODE far *point );
void Case_Wnd( MENU *, CASE far * );                 // 筮 롮
void Case_Wnd_Text( MENU *, CASE far *, CASE far * );     // 筮 롮 
					       //⥪⮢  
void Menu_Wnd( MENU *wnd, CASE far *fn,            //믠饥 
	       MODE far *point );
void Message_Text( CASE  * );                    //뢮 ᮮ饭
void Sound( int, int );                        //ந 㪠  
void Nop( void );                              //誠
char Get_Ich_Text( CASEI far *, char );
char Answ_Menu( CASE  * );
void Init_System( void );              //樠  ०
void Geting_Text( MENU *, CASE far *, char far * );
// 㭪樨  ࠡ⪨  ⢨
void Help( void );                             // ࠢ
void File( void );
void Printer( void );
void Obrabotka( void  );
void Spline( void );
void Uslovia( void );
void Inform( void );
void Exit( void );
void Okruj( void );
void Save_Settings (void),  Restore_Settings (void);
void Wait_Any_Key(void);
//////////////////////////  ""
char Fun_Bar_Keys (char ,KEY far *,int far *);
int Init_Mouse(void); void ms_state(void); void ms_move(int, int);
void set_graph_cursor(int, int, unsigned int far *); int ms_release(void);
void CURSOR_ON(void); void CURSOR_OFF(void);
char Mouse_In_Field (int X1, int Y1, int Xsize, int Ysize,
 int Xnum, int Ynum, int Xdop, int Ydop, int Color, int far *I, int far *J);
//////////////////////////  ""
#endif
